#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cerr.tie(0);

    int64_t n, k;
    cin >> n >> k;

    map<int64_t, int64_t> m;
    vector<int64_t> v;

    for(auto i = 0; i < n; i++)
    {
        int64_t t;
        cin >> t;
        if(m.find(t) != end(m))
            m[t]++;
        else
            m.insert(make_pair(t, 1));
        if(m[t] == k)
            v.push_back(t);
    }

    cout << v.size() << '\n';
    for(auto i = 0; i < v.size(); i++)
        cout << v[i] << ((i < v.size() - 1) ? ' ' : '\n');

    cout.flush();
    return 0;
}